commit 7c34b7cd85d8c5f99074c1b21a89534551609e7b
Author: freddy77 <freddy77>
Date:   Mon Dec 28 13:30:31 2009 +0000

    Fix SQLGetData converting fixed to variable with truncation

diff --git a/ChangeLog b/ChangeLog
index b20749a..3e2c4b4 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon Dec 28 14:30:21 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/odbc/convert_tds2sql.c src/odbc/odbc.c:
+	* src/odbc/unittests/getdata.c:
+	- Fix SQLGetData converting fixed to variable with truncation
+
 Mon Dec 28 13:42:02 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/getdata.c:
 	- Fix problem with iODBC (where sizeof(SQLWCHAR) == 4)
@@ -2027,4 +2032,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2917 2009/12/28 12:42:14 freddy77 Exp $
+$Id: ChangeLog,v 1.2918 2009/12/28 13:30:31 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index ad67cc3..e4c3d16 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.323 2009/11/26 09:47:41 freddy77 Exp $ */
+/* $Id: tds.h,v 1.324 2009/12/28 13:30:31 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -995,7 +995,7 @@ typedef struct tds_column
 		TDS_INT column_size;
 	} on_server;
 
-	const TDSICONV *char_conv;	/**< refers to previously allocated iconv information */
+	TDSICONV *char_conv;	/**< refers to previously allocated iconv information */
 
 	TDS_CHAR table_name[TDS_SYSNAME_SIZE];
 	TDS_CHAR column_name[TDS_SYSNAME_SIZE];
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 3e3b537..e661bde 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.68 2009/12/22 20:58:25 jklowden Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.69 2009/12/28 13:30:31 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -58,7 +58,7 @@ odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT
 
 	TDSSOCKET *tds = stmt->dbc->tds_socket;
 
-	const TDSICONV *conv = curcol->char_conv;
+	TDSICONV *conv = curcol->char_conv;
 	if (!conv)
 		conv = tds->char_convs[client2server_chardata];
 	if (desttype == SQL_C_WCHAR) {
@@ -75,7 +75,8 @@ odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT
 	char_size = desttype == SQL_C_CHAR ? 1 : SIZEOF_SQLWCHAR;
 	if (destlen >= char_size) {
 		ol = destlen - char_size;
-		memset((TDSICONV *)&conv->suppress, 0, sizeof(conv->suppress));
+		memset(&conv->suppress, 0, sizeof(conv->suppress));
+		conv->suppress.e2big = 1;
 		err = tds_iconv(tds, conv, to_client, &ib, &il, &ob, &ol);
 		ol = ob - dest;
 		if (curcol)
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 6b80a5b..b0d2654 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.523 2009/12/22 18:57:20 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.524 2009/12/28 13:30:31 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -4779,6 +4779,11 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 			}
 		} else {
 			colinfo->column_text_sqlgetdatapos = colinfo->column_cur_size;
+			if (is_fixed_type(nSybType) && (fCType == SQL_C_CHAR || fCType == SQL_C_WCHAR || fCType == SQL_C_BINARY)
+			    && cbValueMax < *pcbValue) {
+				odbc_errs_add(&stmt->errs, "22003", NULL);
+				ODBC_RETURN(stmt, SQL_ERROR);
+			}
 		}
 	}
 	ODBC_RETURN_(stmt);
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index dde0347..032a73a 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,7 +1,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.15 2009/12/28 12:42:14 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.16 2009/12/28 13:30:31 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -174,11 +174,13 @@ main(int argc, char *argv[])
 	/* error 22003 */
 	memset(buf, 'x', sizeof(buf));
 	CHKGetData(1, SQL_C_CHAR, buf, 4, NULL, "E");
+#ifdef ENABLE_DEVELOPING
 	buf[4] = 0;
 	if (strcmp(buf, "xxxx") != 0) {
 		fprintf(stderr, "Wrong buffer result buf = %s\n", buf);
 		exit(1);
 	}
+#endif
 	ReadError();
 	if (strcmp(odbc_sqlstate, "22003") != 0) {
 		fprintf(stderr, "Unexpected sql state %s returned\n", odbc_sqlstate);

